#!/usr/bin/python
import re
import sys

if len(sys.argv) < 3:
	print "usage: format.py input output"
	sys.exit(1)

four_per_em = "%c%c%c" % (0xe2, 0x80, 0x85)
nbsp = "%c%c" % (0xc2, 0xa0)

content = open(sys.argv[1]).read()

def add_spacing(m):
	c = m.group(1)
	return "<w:t>" + four_per_em + c.strip() + four_per_em + "</w:t>"

def ruby_annotation(m):
	c = m.group(1)
	s = c
	c = re.sub("<w:t>(.+?)</w:t>", add_spacing, c)
	# print "%s --> '%s'" % (s, c)
	return c

def ruby(m):
	c = m.group(1)
	# print "before: %s" % c
	c = re.sub("val=\"", "vvvvvv=\"", c)
	c = re.sub("</w:r>", "</xxx:r>", c)
	c = re.sub("<w:r>", "<yyy:r>", c)
	c = re.sub("<w:r ", "<zzz:r ", c)
	# print "after: %s" % c
	return c

def ruby_inverse(m):
	c = m.group(1)
	c = re.sub("</xxx:r>", "</w:r>", c)
	c = re.sub("<yyy:r>", "<w:r>", c)	
	c = re.sub("<zzz:r ", "<w:r ", c)
	c = re.sub("vvvvvv=\"", "val=\"", c)
	return c

def repl(m):
	s = m.group(1)
	r = re.search("<w:ruby", s)
	if r:
		return s

	# print "src: %s" % s
	t = re.search("<w:t>(.+?)</w:t>", s)
	if not t:
		t = re.search('<w:t xml:space="preserve">(.+?)</w:t>', s)
		if not t:
			return s

	u = unicode(t.group(1), 'utf-8')
	o = ord(u[0])
	
	if o >= 0x2000:
		return s

	# print "f: %s" % t.group(1)
	# print "f: %s %x" % (t.group(1), ord(u[0]))
	# print m.group(1)
	s = re.sub('val="20"', 'val="28"', s)
	s = re.sub('val="21"', 'val="28"', s)
	# if t.group(1) == "3 ":
	# 	print "s: %s" % s
	return s

def add_space_to_number(m):
	c = m.group(1)
	r = ">" + c + nbsp + "</w:t>"
	# print "%s -> %s" % (m.group(0), r)
	return r

# add four-per-em space around every ruby annotation
content = re.sub(r"(<w:rt>.+?</w:rt>)", ruby_annotation, content)

# temporarily mask all paragraphes inside ruby blocks
content = re.sub(r"(<w:ruby>.+?</w:ruby>)", ruby, content)

# enlarge non-ruby block font size
content = re.sub(r"(<w:r>.+?</w:r>)", repl, content)
content = re.sub(r"(<w:r .+?</w:r>)", repl, content)

# add space to number only text
content = re.sub(r">(\d+)\s*</w:t>", add_space_to_number, content)

# unmask ruby blocks
content = re.sub(r"(<w:ruby>.+?</w:ruby>)", ruby_inverse, content)

# allwr = re.findall(r"<w:r>.+?</w:r>", content)
# allwr = re.findall(r"<w:r .+?</w:r>", content)
# for wr in allwr:
# 	print wr

open(sys.argv[2], "w").write(content)
